/*
	SubSpace player descriptor by Catid@pacbell.net
*/

#ifndef PLAYER_H
#define PLAYER_H

#include "datatypes.h"


enum Operator_Level
{
	OP_Player,				// Requests information services
	OP_Moderator,			// Represents player interests
	OP_SuperModerator,		// Manages moderators
	OP_SysOp,				// Adds/removes/modifies available bot services
	OP_Owner				// Changes internal bot settings
};


// Player

struct Player
{
	Uint16 ident;
	Operator_Level access;

	char name[20];
	char squad[20];
	BYTE banner[96];

	BYTE ship;
	BYTE d;

	Uint16 bounty;
	Uint16 energy;

	Uint16 timer;
	Uint16 S2CLag;

	Uint16 x, y;
	Uint16 xvel, yvel;

	bool stealth, cloak, xradar, awarp, ufo;

	bool shields, super;
	BYTE burst, repel, thor, brick, decoy, rocket, portal;

	Uint16 team;

	Uint32 flagPoints;
	Uint32 killPoints;
	Uint16 wins;
	Uint16 losses;

	bool koth;

	void setBanner(char * bbanner);

	Player(Uint16 iident, char * nname, char * ssquad, Uint32 fflagPoints, Uint32 kkillPoints, Uint16 tteam, Uint16 wwins, Uint16 llosses, BYTE sship);
};


// Brick

struct Brick
{
	Uint16 x, y;
	Uint32 time;
	Uint16 team;
	Uint16 ident;
};


// Flag

struct Flag
{
	Uint16 x, y;
	Uint16 team;	// Not visible when team == PROT_ERROR
	Uint16 ident;
};

#endif	// PLAYER_H
